#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include "gloab.h"
#include "threadread.h"

#include <QMainWindow>
#include <QString>
#include <QDialog>
#include <QVBoxLayout>
#include <QProgressBar>

#include "threadchart.h"
#include "threadpoltchart.h"


QT_BEGIN_NAMESPACE
namespace Ui {
class MainWindow;
}
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void on_openFileBtn_clicked();

    void clearCombo();
    void showStatusbar(const QString &message);
    void setBeginTime(const QDateTime &begin);
    void setEndTime(const QDateTime &begin);
    void addCombo(const QStringList &list);
    void setProgressBar(int percent);
    void closeProg();

    void newCandS();
    void appSeries(qreal A,qreal B);
    void setChartView(int jd,bool isEnum);
    void setWidget();

    void newPlotCandS();
    void setPlotChartView(int jd,bool isEnum);

    void on_lineChart_clicked();

    bool isNumeric(const QString &str);

    void on_plotChart_clicked();

private:
    Ui::MainWindow *ui;
    QLabel *m_versionLabel;
    threadRead *thread_read;
    ThreadChart *thread_chart;
    threadPoltChart *thread_polt;

    QProgressBar *progressBar;
    QVBoxLayout *layout;
    QChart *chart;
    QLineSeries *series;

};
#endif // MAINWINDOW_H
