#ifndef THREADCHART_H
#define THREADCHART_H

#include <QThread>
#include <QDateTime>
#include <QDialog>
#include <QChart>
using namespace QtCharts;
#include <QLineSeries>
#include <QRegularExpression>
#include <QCategoryAxis>
#include <QDateTimeAxis>
#include <QGridLayout>


#include "gloab.h"

class ThreadChart : public QThread {
    Q_OBJECT

public:
    explicit ThreadChart(QObject *parent = nullptr);

    void setValue(QVector<int> jd, QString dataName, QDateTime beginTime, QDateTime endTime);


signals:
    void newCandS();
    void appSeries(qreal A,qreal B);
    void setChartView(int jd,bool isEnum);
    void setWidget();
    void setProgressBar(int percent);

protected:
    void run() override;

private:
    QVector<int> jd;
    QDateTime beginTime;
    QDateTime endTime;
    QString dataName;
};

#endif // THREADCHART_H
